var contentList;
var entity_id;
var navIndex = 0;
var navTotal = 0;
var config_title;
var swiper=null;
let num=0;

var secondPageBg;//传参给二级页面使用
var noStartBg;//应用内其它操作不显示启动页
//推荐表标题
apiready = function() {
	// apicloud的启动页不能全机型自适应，需要在index.html自定义启动页，app启动优先读取显示自适应背景图再关闭返回首页
	// config.xml <preference name="autoLaunch" value="false"/>
	noStartBg = api.pageParam.noStartBg || false;
	if (noStartBg) {
		$api.attr($api.byId('bg'), 'src', 'https://3jidi-1251017968.cos.ap-guangzhou.myqcloud.com//upload/pics/ott_3jd_v2/menu_bg/mfzw_lv1_bg.jpg');
	} else {
		$api.attr($api.byId('bg'), 'src', '../../image/pages/index/start_bg.png');
	}
	api.removeLaunchView({
		animation: {
			type: 'fade',
			duration: 1
		}
	})
	if (noStartBg) {
		// $api.clearStorage();
		if (usePlatformPrivacy.includes(channelType)) { // 20240620 vivo渠道 使用引擎隐私政策弹窗 打包需添加/pages/privacy/privacy.stml文件 其它渠道需删除文件
			$api.setStorage('prevStartup', 1);
			startFn();
		} else { // 使用自定义首页隐私政策弹窗
			new AppStartupLogic();
		}
		api.parseTapmode();
		//只显示一次用户注册协议
		// $api.setStorage('hasrem',false);
	} else {
		// 自定义启动页1.5s后进入首页
		setTimeout(function(){
			// $api.clearStorage();
			if (usePlatformPrivacy.includes(channelType)) {
				$api.setStorage('prevStartup', 1);
				startFn();
			} else {
				new AppStartupLogic();
			}
			api.parseTapmode();
			//只显示一次用户注册协议
			// $api.setStorage('hasrem',false);
		},1500);
	}

	api.addEventListener({
		name : 'keyback'
	}, (ret, err)=> {
		switch(channelType){
			case '3jidi_phone_vivo':
			case '3jidi_phone_dslsc':
			case '3jidi_phone_lazy':
			case '3jidi_phone_huawei':
				closeWd();break;
			default:
				openStayFrame();break;
		}
	});
}

class AppStartupLogic{
	constructor(){
		// $api.clearStorage();
		this.isShowPrivacy();
	}
	isShowPrivacy(){
		let prevStartup = this.getStg('prevStartup');// 获取上次登录的时间,第一次使用app则为undefined
		// console.log(prevStartup)
		// 是否第一次进入app，是显示隐私政策弹窗，否则检测权限
		!prevStartup ? this.showPsBox() : this.checkPms();
	}
	showPsBox(psm=''){// 显示隐私政策框
		$('#psBox').show();
		$('#btn_reject').on('click', ()=>{// 拒绝
			let now = this.nowtime();
			$api.setStorage('prevStartup', now);// 记录这次登录的时间
			$('#psBox').hide();
			this.getStg('temporaryUid') ? startFn() : this.setTemporaryUid();
			api.alert({
				msg: '您也可以在 设置->(更多设置)->权限管理->'+(api.appName||'小学满分作文')+'->电话权限 中打开相关权限，否则有某些功能无法正常运行'
			});
		});
		$('#btn_agree').on('click', ()=>{// 同意
			$('#psBox').hide();
			if(psm) return this.reqPms([psm]);
			this.checkPms();
		});
	}
	checkPms(){// 检测权限
		// 第一次进入应用的话访问权限
		if(!this.getStg('prevStartup')){
			if(noInitPermission.includes(channelType)){
				$api.setStorage('prevStartup', 1);
				return this.getStg('temporaryUid') ? startFn() : this.setTemporaryUid();
			}
			return this.reqPms(['phone-r']);
		}
		// 非第一次进入应用 查询权限
		const resList = hasPermission(['phone-r'],'none')[0]; // console.log($api.jsonToStr(resList));
		if(resList.granted){// IMEI权限已授权 执行页面加载
			if(this.getStg('prevStartup')!='1'){
				$api.setStorage('prevStartup', 1);
			}
			this.removeStorage('temporaryUid');
			// authtype().then(()=>{
			// 	startFn();
			// });
			startFn();
		}else if(noInitPermission.includes(channelType)){// 部分渠道IMEI权限未授权 首页加载也不请求权限
			startFn();
		}else{// IMEI权限未授权 请求权限
			let prevStartup = this.getStg('prevStartup');
			if(!prevStartup || prevStartup!=='1'){
				let now = this.nowtime();
				// 获取上次进入app的时间差
				let difference = this.getHour(prevStartup, now);
				// 当2次时间差大于48小时,显示隐私政策框,否则创建临时唯一码
				if(difference>=48){
					this.showPsBox('phone-r');
					let now = this.nowtime();
					$api.setStorage('prevStartup', now);
				}else{
					this.getStg('temporaryUid') ? startFn() : this.setTemporaryUid();
				}
			}else{// 防止用户同意之后关闭电话权限
				let now = this.nowtime();
				$api.setStorage('prevStartup', now);
				this.showPsBox('phone-r');
			}
		}
		const st = hasPermission(['storage'],'none')[0];
		if(st.granted){
			opendb_common();
		}
	}
	async reqPms(params){// 请求权限
		// 如果是应用宝渠道
		if(channelType==='3jidi_phone_YingYBao'){
			// 自定义遍历器,作用是让一个权限的所有弹框都在用户做出选择后再弹出下一个权限的弹窗，直接用遍历会让弹窗叠在一起
			let iter = params[Symbol.iterator]();
			let item = iter.next();
			do{
				let ret = await this.yybfn(item.value);
				if(ret) item = iter.next();
			}while(!item.done);
		}else{
		// 其他渠道直接请求权限
		    /**
			 * 20220908 修改 全渠道优先说明框 再弹出获取权限框
			 */
			// this.requestPmss(params);
			let iter = params[Symbol.iterator]();
			let item = iter.next();
			do{
				let ret = await this.yybfn(item.value);
				if(ret) item = iter.next();
			}while(!item.done);
		}
	}
	yybfn(params){// 应用宝渠道执行的
		// 弹窗
		return this.myConfirm(params).then(ret=>{
			// 点击了确定，执行询问权限操作
			if(ret.buttonIndex==1){
				return this.requestPmss(params);
			}else{
			// 点击取消，或者空白的时候
				if(params==='phone-r'){
					let now = this.nowtime();
					$api.setStorage('prevStartup', now);
					this.getStg('temporaryUid') ? startFn() : this.setTemporaryUid();
				}
				// value:传过来的参数、granted：false代指点击取消、buttonIndex：点了空白还是取消、isWriteBySelf：是不是自己写的垃圾;
				return {value: params, granted: false, buttenIndex:ret.buttenIndex, isWriteBySelf: true};
			}
		});
	}
	myConfirm(params){// 弹窗询问是否要给权限
		// console.log(params)
		let title = 'IMEI',
			msg = '为保证您正常、安全地使用，需要获取设备识别码（部分手机提示为获取手机号码）使用权限，请允许。';
		if(params==='storage'){
			title = '存储',
			msg = '应用保存运行状态等信息，需要获取读写手机存储（系统提示为访问设备上的照片、媒体内容和文件）权限，请允许。';
		}
		return new Promise (resolve=>{
			api.confirm({
				title: title +'权限请求',
				msg: msg,
				buttons: ['确定', '取消']
			},ret=>{// 2-取消，0-点了空白地方，1-确定
				resolve(ret);
			})
		})
	}
	requestPmss(params){// 请求权限的弹窗
		return new Promise(resolve=>{
			api.requestPermission({
				list: Array.isArray(params) ? params : [params]
			}, ret=>{
				// console.log(JSON.stringify(ret));
				resolve(ret.list[0]);
				if(ret.list[0].name==='phone-r'){
					if(ret.list[0].granted){// 同意imei请求
						$api.setStorage('prevStartup', 1);
						this.removeStorage('temporaryUid');
						startFn();
					}else{// 拒绝imei请求
						let now = this.nowtime();
						$api.setStorage('prevStartup', now);
						this.getStg('temporaryUid') ? startFn() : this.setTemporaryUid();
						api.setGlobalData({
							key: 'reqPmsNum',
							value: 1
						});
					}
				}else if(ret.list[0].name==='storage'){
					ret.list[0].granted ? opendb_common() : '';
				}
			});
		});
	}
	setTemporaryUid(){// 设置临时的唯一码
		const arr=['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9'];
		let subStr=Date.now();
		for(let i=0;i<6;i++){
			subStr += arr[Math.floor((Math.random()*arr.length))];
		}
		$api.setStorage('temporaryUid', subStr);
		startFn();
	}
	removeStorage(pms){// 删除存储
		if(this.getStg(pms)){
			$api.rmStorage(pms);
		}
	}
	nowtime(){// 获取当前时间，格式：2022-5-30 14:39:00
		let myDate = new Date();
		let year = myDate.getFullYear(),
		month = myDate.getMonth() + 1,
		dates = myDate.getDate();
		// return myDate.toLocaleDateString().replace(/\//g, "-") + " " + myDate.toTimeString().substr(0, 8);
		return year+'-'+month+'-'+dates+ " " + myDate.toTimeString().substr(0, 8);
	}
	getHour(s1, s2) {// 获取2个时间的时差，例如：3，表示相差3小时
		var reDate = /\d{4}-\d{1,2}-\d{1,2} /;
		s1 = new Date((reDate.test(s1) ? s1 : '2022-1-1 ' + s1).replace(/-/g, '/'));
		s2 = new Date((reDate.test(s2) ? s2 : '2022-1-1 ' + s2).replace(/-/g, '/'));
		var ms = s2.getTime() - s1.getTime();
		if (ms < 0) return 0;
		return Math.floor(ms / 1000 / 60 / 60);  //小时
	}
	getStg(param, type='normal'){// 获取存储数据
		if(typeof param !== 'string') return param+ '，sb，传字符串！！！！字符串懂吗傻逼！';
		let str = $api.getStorage(param) || '';
		if(type == 'normal'){
			return str;
		}
		return Promise.resolve(str);
	}
}

function startFn(){
	// if(channelType.indexOf("huawei")>-1 || channelType.indexOf("vivo")>-1) {
	// 	hwDataControl();
	// }
	// if(channelType == '3jidi_p_huawei_ct'){
	// 	var hmsCT = api.require('hmsmodule');
	// 	hmsCT.hmsXXTBKTAgent();//初始化
	// 	hmsCT.hmsXXTBKTConnect(function(ret,err){//调用connect
	// 		console.log($api.jsonToStr(ret));
	// 		if(ret && ret.code == 0){//返回0时执行更新操作
	// 			hmsCT.hmsXXTBKTCheckUpdate();
	// 		}else console.log($api.jsonToStr(err));
	// 	});
	// }else if(channelType == '3jidi_phone_xiaomi'){
	// 	try{
	// 		const xm = api.require('xiaomimodule');
	// 		// xm.XiaoMiApplication();
	// 		xm.XiaoMiAgent({
	// 			appId: '2882303761517634065',
	// 			appKey: '5721763414065'
	// 		},(ret,err)=>{
	// 			if(ret){
	// 				// console.log('success-------'+JSON.stringify(ret));
	// 				api.alert({msg:'success-------'+JSON.stringify(ret)})
	// 			}
	// 			if(err)	{
	// 				// console.log('error------'+JSON.stringify(err));
	// 				api.alert({msg:"ERROR----"+JSON.stringify(err)})
	// 			}
	// 		});//初始化
	// 		// xm.XiaoMiOne({msg:111111111111})
	// 		// 小米支付模塊跟友盟模塊衝突，小米渠道不加载友盟
	// 	}catch(err){
	// 		console.log('err------',JSON.stringify(err));
	// 	}
	// }
	authV2().then(ret=>{
		// console.log(JSON.stringify(ret))
		$api.setStorage('uCode', ret.uCode);
		$api.setStorage('userid', ret.userid);
		// opendb_common();
		return findUserMsgV2();//查询用户信息
	}).then(res=>{
		// console.log('findUserMsgV2',JSON.stringify(res));
		api.setGlobalData({
			key: 'pName',
			value: res.pName || ''
		});
		$api.setStorage('pName', res.pName || '');
		$api.setStorage('pEndTime', res.pEndTime || '');
		$api.setStorage('uPhoneNum', res.uPhoneNum || '');
		//初始化数据加载
		getIndexDate('3JD_MFZW_HOME_HEAD_MENU');
		if(res&&!res.pName){
			var myDate = new Date();
			var year = myDate.getFullYear();
			//获取当前年
			var month = myDate.getMonth() + 1;
			//获取当前月
			var date = myDate.getDate();
			//获取当前日
			var now = year + '-' + month + "-" + date;
			var now_time = $api.getStorage('now_time');
			if(now_time != now){
			// if(true){
				$api.setStorage('now_time', now);
				api.openWin({
					name : 'ad_window',
					url : './ad_window.html'
				});
			}
			// if(!noAdChannel.includes(channelType)){
			// 	const ADM = api.require('AdmobileModule');
			// 	ADM.AdInit({
			// 		APP_ID: '3096064',
			// 		SPLASH_AD_POS_ID1: '152717dd16934a0f32',
			// 		debug: true
			// 	});
			// 	ADM.AdActivity();
			// }
		}
	})
}

//数据加载
function getIndexDate(categorykind) {
	$api.css($api.byId('agreement'),'opacity:1');
	api.ajax({
		url : ios_configURL + '/' + categorykind + '/' + apkTypeConfig,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {
			values : {}
		},
		returnAll : false,
	}, function(ret, err) {
		if (ret) {
			// console.log(JSON.stringify(ret))
			if (categorykind == '3JD_MFZW_HOME_HEAD_MENU') {//导航页数据
				//初始化导航栏个数
				$api.attr($api.byId('bg'), 'src', ret[0].picture);	
				secondPageBg = ret[0].picture;
				var html_ = '';
				for (var i = 0; i < ret.length; i++) {
					html_ += '<div class="swiper-slide"></div>';
				}
				$api.html($api.byId('swiper-wrappe'), html_);

				//初始化头部导航栏样式
				initTabSwiper(ret);
			}
		}
	});
}

//(初始化导航栏)
function initTabSwiper(datas) {
	swiper = new Swiper('.swiper-container', {
		pagination : {
			el : '.swiper-pagination',
			clickable : true,
			renderBullet : function(index, className) {

				if (datas[index]) {
					var html_ = '<span class="' + className + '">';
					html_ += '<img class="default" src="' + datas[index].btn_default + '" />';
					html_ += '<img class="focus" src="' + datas[index].btn_focused + '" />';
					html_ += '</span>';
				}

				return html_;
			}
		},
		on : {
			init : function() {
				//初始化执行mySwiper.slides.length
				//alert('当前的slide序号是'+this.slides.length);
				navIndex = this.activeIndex;
				navTotal = this.slides.length;
				this.emit('transitionEnd');
				//在初始化时触发一次transitionEnd事件
			},
			slideChangeTransitionStart : function() {
				//切换执行
				//alert(this.activeIndex);
				navIndex = this.activeIndex;
				selCourse(navIndex, datas[navIndex].entityId, datas[navIndex].kind);
			},
		},
	});

	//初始化内容列表（示例默认加载第一个）
	contentList = $api.domAll($api.byId('swiper-wrappe'), 'div.swiper-slide');
	setBtnTbkt();
	selCourse(0, datas[0].entityId, datas[0].kind);
}

//聚合按钮
function setBtnTbkt(){
	var html_ = `<span class="swiper-pagination-bullet" onclick="goJuhe()">
		<img class="default" src="../../image/pages/index/other_app.png" />
	</span>`;
	$api.append($api.byId("swiper-pagination"),html_);
	if(api.winWidth<620){
		$(".swiper-pagination-bullet").css({"height":"60%"});
		$(".activity").css({"height":"50%"});
	}
}

// 打开小学
function goJuhe(){
	api.openWin({
		name: 'xxIndex',
        // url: '../juhe_index.html'
        url: '../xxPage/xxIndex.html'
    });
	// api.closeWin({
	// 	name: 'zwIndex',
	// 	animation: {
	// 		type:"push",                //动画类型（详见动画类型常量）
	// 		subType:"from_right",       //动画子类型（详见动画子类型常量）
	// 		duration:300                //动画过渡时间，默认300毫秒
	// 	}
	// });
}

//获取课程内容
function selCourse(index, entityId, kind) {
	//我的页面
	if (kind == '' || kind == null || kind == undefined || kind == 'null') {
		$api.css($api.byId('filings'),'opacity:0;z-index:-10');
		getUser(index);
	} else {
		$api.css($api.byId('filings'),'opacity:1;z-index:10');
		//加载普通模板页面数据
		api.ajax({
			url : ios_configURL + entityId + '/' + apkTypeConfig,
			method : 'post',
			cache : false,
			timeout : 30,
			dataType : 'json',
			data : {
				values : {}
			},
			returnAll : false,
		}, function(ret, err) {
			if (ret) {
				// console.log($api.jsonToStr(ret));
				//模板页面数据
				var html_ = '';
				html_ += '<div class="slide-list">';
				html_ += '<ul class="page-conten">';
				for (var i = 0; i < ret.length; i++) {
					html_ += '<li onclick="transit(\''+ret[i].entityId+'\',\''+ret[i].linkrule+'\',\''+ret[i].entitygrade+'\',\''+entityId+'\')"><img src="' + ret[i].picture + '"/></li>';	
				}
				if(ret.length % 4  > 0){
					var len = 4 - ret.length % 4;
					for(var a=0;a<len;a++){
						html_ += '<li></li>';
					}
				}
				html_ += '</ul>';
				html_ += '</div>';
				if ($api.html(contentList[index]).length == 0) {
					$api.html(contentList[index], html_);
				}
			}
		});
	}
}

//华为渠道数据显示控制
function hwDataControl() {
	api.ajax({
		url : domain + '/app/dic/getXHVersion/is_show_hujiao',
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {},
		returnAll : false,
	}, function(ret, err) {
		// console.log($api.jsonToStr(ret))
		if (ret&&ret[0].icon) $api.setStorage("hwDataControl",ret[0].icon);
		else console.log($api.jsonToStr(err));
	});
}

/*中转方法判断跳转页面*/
function transit(entityId,linkrule,entitygrade,kind){
	if(kind=='xx_zw_05'){
		api.openWin({
			name : 'tbzw_window',
			url : './tbzw_window.html',
			pageParam : {
				tree_id : entityId,
				linkrule:linkrule,
				entitygrade:entitygrade,
				kind: ''
			}			
		});
	}else{
		api.openWin({
			name : 'tbzw_window',
			url : './tbzw_window.html',
			pageParam : {
				tree_id : entityId,
				linkrule:linkrule,
				entitygrade:entitygrade,
				kind: kind,

				secondPageBg: secondPageBg
			}			
		});
	}
}