//var phoneNumber = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
var phoneNumber = /^(1[3-9])\d{9}$/;

apiready = function() {
	if(!['3jidi_phone_huawei', '3jidi_phone_360'].includes(channelType)) checkPms();
	//防止键盘压缩页面，body要加绝对定位
	var Height = $('body').height();
	$(window).resize(function() {
	    $('body').height(Height);
	});
	//监听checkCode传回来的事件
	api.addEventListener({
	    name:'useTimeThis'
    },function(ret,err){
    	var dom = $api.byId("btn");
    	timeThis(dom);
    });
	var mobilephone = $api.getStorage('loginid');
	$('#phone').val(mobilephone);
	setStyle();
};

function setStyle(){
	$api.removeCls($api.byId('login_l'), 'login_l_change');
	$api.css($api.byId('list1'), 'line-height:' + api.winHeight * 0.675 * 0.5 * 0.2 + 'px;');
	$api.css($api.byId('list2'), 'line-height:' + api.winHeight * 0.675 * 0.5 * 0.2 + 'px;');
}

var isClick=true;
function login() {
	if(isClick) {
		isClick = false;
		var loginid = $api.trim($api.val($api.byId('phone')));
		var passwd = $api.val($api.byId('passwd'));
		if (loginid.length <= 0) {
			isClick=true;
			alert('手机号码不能为空!');
			return;
		}
		if (passwd.length < 6) {
			isClick=true;
			alert('密码格式错误!');
			return;
		}
		logEvent(loginid, passwd);
	}
}

function logEvent(loginid, passwd){
	api.ajax({
		url : userURL + '/v2/login',
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {
			values : {
				uniqueStr : getDeviceId(),
				userName : $api.getStorage('uCode'),
				password : passwd,
				phone : loginid,
				apkType : apkType,
				channelType : channelType,
				deviceName : api.uiMode.toUpperCase()
			}
		},
		returnAll : false
	}, function(ret, err) {
		if (ret) {
			if (ret.code == '200') {
				findUserMsgV2().then(ret=>{
					api.setGlobalData({
						key: 'pName',
						value: ret.pName || ''
					});
					// $api.setStorage('pName', ret.pName);
				});
				//录入用户信息在本地
				$api.setStorage('loginState', ret.sessionId);
				//设置登录状态
				$api.setStorage('loginid', loginid);
				//记录登录loginid
				var windows = api.windows();
				var obj='';
				if(windows[windows.length-1].name==='zwIndex') obj='./pages/index.html';
				else if(windows[windows.length-1].name==='xxIndex') obj='./xxPage/xxIndex.html';
				api.openWin({
					name : windows[windows.length-1].name,
					url : obj,
					reload : true,
                    pageParam : {
                        noStartBg : true
                    }
				});
				api.toast({
					msg : ret.msg,
					duration : 3000,
					global : true
				});
				setTimeout(function() {
					api.closeFrame();
				}, 500)
			} else if (ret.code != null && ret.code != '' && ret.code != undefined) {
				isClick=true;
				api.alert({
					msg : ret.msg
				});
			}
		}
	});
}

//找回密码1
function findPsw(){
	status = true;
	var html = '';
	var html_btn='';
	html += '<div class="list1" id="verify">';
		html += '<span>验证码：</span><input id="core" type="text" value=""/>';
		html += '<div class="vCode" id="vCode">';
			html += '<input display="true" type="button" id="btn" value="获取验证码" onclick="getCode()"/>';//,timeThis(this)
		html += '</div>';
	html += '</div>';
	$api.byId("list1").insertAdjacentHTML('afterend',html);//插入验证码
	$api.html($api.byId("pw"), "新&nbsp;&nbsp;密&nbsp;&nbsp;码：");
	$api.css($api.dom('.input_list'),'top:27%;');
	$('.list1').css('marginBottom','5%');
	if(status){
		html_btn += '<img src="../image/pages/login/sure.png" onclick="setPsw()" />';//找回按钮
		html_btn += '<img src="../image/pages/login/close.png" onclick="backLogin()" />';//跳过按钮
		$api.html($api.byId("list_btn"), html_btn);
	}
	
//	console.log($api.byId("phone").value)
	var phone_num = $api.byId("phone").value;
	if(phone_num != '' || phone_num != undefined || phone_num != null){
		phoneNumTest();
	}
}

function phoneNumTest(){
	var phone = $api.trim($api.val($api.byId('phone')));
	var phoneNumber = /^(1[3-9])\d{9}$/;
	if($api.byId("btn")){
		if (phoneNumber.test(phone)) {
			$api.removeAttr($api.byId('btn'), "disabled");
			$("#vCode").css('background-color', '#49b742');
			$("#btn").css('color', '#fff');
		}else{
			$api.attr($api.byId('btn'), "disabled", true);
			$("#vCode").css('background-color', '#ccc');
			$("#btn").css('color', '#000');
		}
	}
}

$("#phone").keyup(function() {
	phoneNumTest();
});

//获取验证码
function getCode() {
	var phone = $api.trim($api.val($api.byId('phone')));
	var phoneNumber = /^(1[3-9])\d{9}$/;
	if (!phoneNumber.test(phone)) {
		alert('请输入正确的手机号码!');
		return;
	}
	var WinHeight=$api.dom("body").clientHeight;
	api.openFrame({
	    name: 'checkCode',
	    url: './checkCode.html',
	    rect: {
		    x:0,
		    y:0,
		    w:api.winWidth,
		    h:WinHeight
	    },
		pageParam : {
			phone:phone,
			operatetype:1
		}
    });
}

//获取验证码倒计时
var wait = 60;
function timeThis(o) {//console.log("timeThis==="+o.value)
	var phone = $api.trim($api.val($api.byId('phone')));
	var phoneNumber = /^(1[3-9])\d{9}$/;
	if (!phoneNumber.test(phone)) {
		return;
	}
	if (wait == 0) {
		$("#vCode").css('background-color', '#49b742');
		$("#vCode").css('color', '#FFFFFF');
		o.removeAttribute("disabled");
		o.value = "获取验证码";
		wait = 60;
	} else {
		if (wait == 60) {
			$("#vCode").css('background-color', '#ccc');
			$("#btn").css('color', '#000');
		}
		o.setAttribute("disabled", true);
		o.value = "重新发送(" + wait + ")";
		wait--;
		setTimeout(function() {
			timeThis(o)
		}, 1000);
	}
}

//设置新密码
function setPsw(){
	var phoneNum = $api.trim($api.val($api.byId('phone')));
	var verify = $.trim($("#core").val());
	var passwd = $api.val($api.byId('passwd'));
	if (phoneNum.length <= 0) {
		alert('手机号码不能为空!');
		return;
	}
	if (!isPasswd(passwd)) {
		return alert('密码格式错误，密码格式为6~20位以字母或数字开头，可加部分特殊字符。');
	}
	api.ajax({
		url : domain + '/user/u/v2/findPassword',
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {
			values : {
				apkType : apkType,
				channelType : channelType,
				uniqueStr : getDeviceId(),
				userName : $api.getStorage('uCode'),
				phone : phoneNum,
				verify : verify,
				password : passwd,
				deviceName : api.uiMode.toUpperCase()
			}
		},
		returnAll : false
	},function(res,err){
//		console.log(JSON.stringify(res));
		if(res){
			api.toast({
				msg : res.msg,
				duration : 2000,
				global : true
			});
			if(res.code == '200'){
				logEvent(phoneNum, passwd);
			}
		}
	});
}

function backLogin(){
	$api.addCls($api.byId('login_l'), 'login_l_change');
	api.sendEvent({
	    name:'closeCurWin'
    });
	window.setTimeout('api.closeFrame()',1000)
}