var videoPlayer;
//播放器线路
var videpType;
//视频id
var videoid;
//zt_list表id
var list_id = '';
//
var videoName;
//是否免费  用于保存播放日志记录数据
// var is_free;

//视频参数信息
var duration = 0;
//视频总时长
var nowPlayTimes = 0;
//当前播放
var eventType = '';
//字符串类型；播放事件类型，仅当 name 为 play 时有值；取值范围如下：//start（开始播放）//playing（正在播放）//pause（播放暂停）//stop（播放停止）//complete（播放完成）
var videoURL = '';
//视频播放地址

//视频控制栏是否显示
var videoControlTypes = true;

//播放下一条视频
var menuType;
var playData;
var playIndex;
var totalIndex;
var is_free;

// 鉴权标识
var isAuth;
// 隐藏工具栏定时器
var set;
// 续播定时器
var setSecond;
// 重播记录地址
var replayUrl = '';
// 播放鉴权区分聚合应用
var play_apkType;

apiready = function() {
	//显示进度提示框
	api.showFloatBox({
		iconPath : 'widget://image/loading_more.gif',
		duration : 3000
	});

	//获取播放器播放线路
	videpType = $api.getStorage('videType');
	if (videpType == undefined || videpType == '' || videpType == null) {
		videpType = 0;
	}

	//获取传递参数
	videoPlayer = api.require('videoPlayer');
	videoid = api.pageParam.sourceid;
	list_id = api.pageParam.list_id;
	is_free = api.pageParam.is_free;

	menuType = api.pageParam.menuType;
	entityId = api.pageParam.entityId;
	zhztinfoid = api.pageParam.zhztinfoid;
	playIndex = api.pageParam.playIndex;
	//作文跳转播放页传参play_apkType='xx_zw'
	//小学跳转播放页不传参默认play_apkType='xxtbkt'
	play_apkType = api.pageParam.play_apkType || apkType_xx;

	if (list_id == null || list_id == '' || list_id == undefined || list_id == 'undefined') {
		list_id = '';
	}
	if(menuType && menuType.indexOf('tbdc') != -1){
		selAllVideo();
	}

	//查询需要播放的视频videoid
	selvideo(videoid, 'open', '');

	//监听当前页面事件
	addEventListenerPlay();

	// 插入广告
	var pName = api.getGlobalData({
		key:'pName'
	});
	if((pName=="undefined" || !pName) && !noAdChannel.includes(channelType)){
		adFn();
	}

	myAuth({
		subjectid: list_id,
		apkType: play_apkType
	}).then(res=>{
		if(res.result){// success
			isAuth = true
		} else {
			isAuth = false
		}
	});

	api.addEventListener({
        name:'handleControl'
    },function(ret,err){
		//点击显示隐藏
		window.clearTimeout(set);
		if (videoControlTypes) {
			hideControl();
		} else {
			showControl();
		}
    });
	api.addEventListener({
        name:'handleReplay'
    },function(ret,err){
		window.clearTimeout(setSecond);
		setSecond = null;
		//播放完成后playIndex会一直加一，点击重播后需减一重置playIndex，下次自动连播才是下一条视频
		playIndex = parseInt(playIndex) - 1;
    	setPath(replayUrl);
    });
};


//广告
function adFn(){
	const ADM = api.require('AdmobileModule');
	ADM.AdInit({
		APP_ID: '3096064',
		SPLASH_AD_POS_ID1: '152717dd16934a0f32',//开屏广告
		debug: true
	});
	ADM.AdInsertScreen({
		INTERSTITIAL_AD_POS_ID: '53335afc6b823f7e9d'//插屏广告
	},function(res){
		// console.log($api.jsonToStr(res))
		if(res && res.code==0) {
			ADM.ShowInsertScreen();
		}
	});// 插屏广告
}


//查询视频信息
function selvideo(videoid, type, videoName) {
	var url = playURL + videoid;
	if(is_free==0) url = playURL +'v2/'+ videoid;
	api.ajax({
		url : url,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {
			values : {
				list_id : list_id,
				apk_type: apkType
			}
		},
		returnAll : false
	}, function(ret, err) {
		if (ret) {
			videoURL = ret.qcloud_video_url_05;
			videoName = ret.source_video_name;
			replayUrl = videoURL;
			if (type == 'open') {
				if (videpType == 1) {//打开播放器（不可编辑样式播放器）
					fnvideoPlayerPlay(videoURL, videoName);
				}else {//打开播放器（可编辑样式播放器）
					fnvideoPlayerOpen(videoURL, videoName);
				}
			}
			if (type == 'notopen') {
				setPath(videoURL);
				$api.html($api.byId('title'), videoName);
			}
		} else {
//			api.toast({
//				msg : err.msg,
//				duration : 3000,
//				global : true
//			});
			console.log(JSON.stringify(err));
			$api.dom('html').innerHTML = err.body;
		}

	});
}

//调用普通视频播放器（可编辑播放器）
function fnvideoPlayerOpen(videoURL, videoName) {
	videoPlayer.open({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : api.winWidth, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : api.winHeight //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		bg : '#000', //视频背景颜色，支持#、rgb、rgba (在切换视屏为了防止闪屏,请根据自己的视频调节颜色)
		path : videoURL, //视频播放地址
		autoPlay : true, //打开时是否自动播放
//		scalingMode : 'scaleToFill', //该参数仅支持ios
		coverImg : "widget://image/videoPlayer/video_load.png" //播放器打开尚未播放时的封面图
	}, function(ret, err) {
		if (ret.status) {
			//alert(JSON.stringify(ret));
			//获取视频总时长
			if (ret.duration != '' && ret.duration != null && ret.duration != 'undefined') {
				duration = ret.duration;
			}
			//默认5s之后自动隐藏控制栏
			showControl();

			//打开自定义播放器样式
			openVideoController();
			openVideoMiddle();
			openVideoTool();

			//监听播放器事件
			videoPlayerAddEventListener();
		} else {
			//alert(JSON.stringify(err));
			api.toast({
				msg : err.msg,
				duration : 2000,
				location : 'middle'
			});
		}
	});
}

//调用普通视频播放器（不可编辑播放器）
function fnvideoPlayerPlay(videoURL, videoName) {
	videoPlayer.play({
		texts : {
			head : {
				title : '视频' //视频名称
			}
		},
		styles : {//播放默认样式效果
			head : {
				bg : 'rgba(0,0,0,0.7)',
				height : 44,
				titleSize : 20,
				titleColor : '#fff',
				backSize : 30,
				backImg : 'widget://image/videoPlayer/back.png',
				setSize : 30,
				setImg : 'widget://image/videoPlayer/more.png'
			},
			foot : {
				bg : 'rgba(0,0,0,0.7)',
				height : 44,
				playSize : 30,
				playImg : 'widget://image/videoPlayer/play.png',
				pauseImg : 'widget://image/videoPlayer/pause.png',
				nextSize : 0,
				nextImg : '',
				timeSize : 14,
				timeColor : '#fff',
				sliderImg : '',
				progressColor : '#696969',
				progressSelected : '#1296db',
				fullscreenImgSize : 30,
				verticalImg : "widget://image/videoPlayer/fullscreen.png",
				horizontalImg : "widget://image/videoPlayer/unfullscreen.png"
			}
		},
		path : videoURL, //播放地址
		autoPlay : true //是否自动播放
	}, function(ret, err) {
		if (ret) {
			if (ret.eventType == 'back') {//返回
				backWin();
			} else if (ret.eventType == 'failed') {
				//alert('播放失败')
			}
		} else {
			//alert(JSON.stringify(err));
		}
	});
}

//打开自定义播放器样式
function openVideoController() {
	api.openFrame({
		name : 'video_foot_01',
		url : '../videoPlayer/video_foot_01.html',
		bounces : false,
		rect : {
			x : 0,
			y : api.winHeight - 50,
			w : 'auto',
			h : 50
		},
		reload : true,
		slidBackEnabled : false,
		pageParam : {
			duration : duration,
			menuType : menuType
		}
	});
}

function openVideoTool() {
	api.openFrame({
		name : 'video_head_01',
		url : '../videoPlayer/video_head_01.html',
		bounces : false,
		rect : {
			x : 0,
			y : 0,
			w : 'auto',
			h : 50
		},
		reload : true,
		slidBackEnabled : false,
		pageParam : {
			videoName : videoName
		}
	});
}

//设置视频播放时间
function seekToPlay(times) {
	// 点击进度条取消自动播放下一条
	if (setSecond) {
		window.clearTimeout(setSecond);
		setSecond = null;
		//播放完成后playIndex会一直加一，出现重播按钮后，点击进度条重播时需减一重置playIndex，下次自动连播才是下一条视频
		playIndex = parseInt(playIndex) - 1;
		hideMiddle();
	}
	if (eventType && eventType.replace(/\"/g, "") == 'complete') {
		//videoPlayer.seekTo({seconds: 0});
		videoPlayer.setPath({
			path : videoURL,
			coverImg : "widget://image/videoPlayer/video_load.png" //播放器打开尚未播放时的封面图
		});
	}
	videoPlayer.seekTo({
		seconds : times
	});
	videoPlayerAddEventListener();
}

function selAllVideo(){
	var pageSize = 100;
	api.ajax({
		url : ztGroupURL + '/course/' + zhztinfoid + '/' + 1 + '?pageSize=' + pageSize,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {},
		returnAll : false,
	}, function(ret, err) {
		if (ret) {
			// console.log(JSON.stringify(ret.result))
			playData =  ret.result;	
			totalIndex = playData.length;
		} else {
			//console.log('获取课程列表失败')
		}
	});
}

function nextPlay(){
	//播放下一条视频
	playIndex = parseInt(playIndex) + 1;
	if(playIndex < totalIndex){
		var list = playData[playIndex];
		// 免费或者已有权限
		if (list.is_free == 0 || isAuth) {
			// selvideo(list.sourceid, 'notopen', '');
			// 续播显示倒计时5秒
			showMiddle(list.sourceid, 'notopen', '');
		} else {
			// 跳转订购页
			api.confirm({
				title: '提示',
				msg: '您尚未拥有权限，是否前往购买权限',
				buttons: ['确定', '取消']
			}, (ret, err)=> {
				if(ret.buttonIndex == 1){
					let payParam = {
						// apkType_xx,
						entityId
					};
					openWindow ('payWin','../android_order.html',payParam);
				}
			});
		}
	}
}

function openVideoMiddle() {
	api.openFrame({
		name : 'video_middle_01',
		url : '../videoPlayer/video_middle_01.html',
		bounces : false,
		rect : {
			x : api.winWidth * 0.35,
			y : api.winHeight * 0.8 - 55,
			w : api.winWidth * 0.3, 
			h : api.winHeight * 0.2
		},
		reload : true,
		slidBackEnabled : false,
	});
}

//设置播放器播放视频地址
function setPath(videoPath) {
	videoPlayer.setPath({
		path : videoPath,
		coverImg : 'widget://image/videoPlayer/video_load.png'
	});
}

//视频播放器监听事件
function videoPlayerAddEventListener() {
	videoPlayer.addEventListener({
		name : 'leftUp'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'leftDown'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'rightUp'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'rightDown'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			// alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'swipeLeft'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'swipeRight'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	//屏幕点击事件
	videoPlayer.addEventListener({
		name : 'click'
	}, function(ret, err) {
		if (ret) {
			//点击显示隐藏
			window.clearTimeout(set);
			if (videoControlTypes) {
				hideControl();
			} else {
				showControl();
			}

		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'play'
	}, function(ret, err) {
		if (ret) {
			nowPlayTimes = JSON.stringify(ret.current);
			eventType = JSON.stringify(ret.eventType);
			if ('complete' == eventType.replace(/\"/g, "")) {
				api.removeEventListener({
					name : 'playType'
				});
				api.sendEvent({
					name : 'playType',
					extra : {
						eventType : eventType
					}
				});
			} else if ('playing' == eventType.replace(/\"/g, "")) {
				api.sendEvent({
					name : 'playType',
					extra : {
						nowPlayTimes : nowPlayTimes,
						eventType : eventType
					}
				});
			}

		} else {
			//alert(JSON.stringify(err));
		}
	});

}

//moviePlayer监听组件
function moviePlayerAddEventListener(isFullscreen){
	moviePlayer.addEventListener(function(ret){
	    if(ret && ret.eventType == 'back'){
	    	moviePlayer.close();
	        api.closeWin();
	    }else{
	    	if( JSON.stringify(ret.eventType).replace(/\"/g, "").replace(/[\\]/g, '') == 'customBtns'){
	    		alert(JSON.stringify(ret.index).replace(/\"/g, "").replace(/[\\]/g, ''))
	    	}else{
		    	//alert(JSON.stringify(ret.eventType))
	    	}
	    }
	});
}

//视频播放
function videoPlay() {
	videoPlayer.start();
}

//视频暂停
function videoPause() {
	// 点击播放/暂停按钮 取消自动播放下一条
	if (setSecond) {
		window.clearTimeout(setSecond);
		setSecond = null;
		//播放完成后playIndex会一直加一，出现重播按钮后，点击播放/暂停按钮重播时需减一重置playIndex，下次自动连播才是下一条视频
		playIndex = parseInt(playIndex) - 1;
		hideMiddle();
	}
	videoPlayer.pause();
}

//视频全屏
function fullScreen() {
	videoPlayer.fullScreen();
	var winWidth = api.winWidth;
	var winHeight = api.winHeight;
	var w;
	var h;
	if (winWidth > winHeight) {
		w = winWidth;
		h = winHeight;
	} else {
		w = winHeight;
		h = winWidth;
	}
	videoPlayer.setRect({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : w, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : h //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		fullscreen : true
	});
	api.setFrameAttr({
		name : 'video_foot_01',
		rect : {
			x : 0,
			y : h - 50,
			w : w,
			h : 50
		},
	});
}

//视频非全屏
function unfullScreen() {
	videoPlayer.cancelFullScreen();
	var winWidth = api.winWidth;
	var winHeight = api.winHeight;
	var w;
	var h;
	if (winWidth > winHeight) {
		w = winHeight;
		h = winWidth;
	} else {
		w = winWidth;
		h = winHeight;
	}
	videoPlayer.setRect({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : w, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : w * 0.75 //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		fullscreen : false
	});
	api.setFrameAttr({
		name : 'video_foot_01',
		rect : {
			x : 0,
			y : w * 0.75 - 50,
			w : w,
			h : 50
		},
	});
}

function hideMiddle(videoid, type, videoName) {
	api.sendEvent({
		name : 'videoMiddle',
		extra : {
			videoMiddleType:0
		}
	});
	if (videoid) selvideo(videoid, type, videoName);
}

function showMiddle(videoid, type, videoName) {
	api.sendEvent({
		name : 'videoMiddle',
		extra : {
			videoMiddleType:1,
			videoMiddleWait:5,
		}
	});
	window.clearTimeout(setSecond);
	setSecond = window.setTimeout(function() {
		hideMiddle(videoid, type, videoName);
	}, 5000);
}

function hideControl() {
	videoControlTypes = false;
	api.sendEvent({
		name : 'videoControl',
		extra : {
			videoControlType : 0
		}
	});
}

function showControl() {
	videoControlTypes = true;
	api.sendEvent({
		name : 'videoControl',
		extra : {
			videoControlType : 1
		}
	});
	//
	window.clearTimeout(set);
	set = window.setTimeout(function() {
		hideControl();
	}, 5000);
}

//监听当前页面事件
function addEventListenerPlay() {
	//安卓返回键
	androidKeyBack();
}

//安卓返回键
function androidKeyBack() {
	api.addEventListener({
		name : 'keyback'
	}, function(ret, err) {
		api.closeWin();
	});
}